/***************************************************************************
              centerline.h  -  convert pixels to centerlines
                             -------------------
    begin                : Thu Sep 5 2002
    copyright            : (C) 2002 by Adam Tofilski
    email                : rotofils@cyf-kr.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CENTERLINE_H
#define CENTERLINE_H

#include "pxl-outline.h"
#include "types.h"
#include "drawwing.h"
#include "spline.h"

extern void
find_short_otl(pixel_outline_list_type *outlines, unsigned too_short);

#ifdef _EXPORTING
/* Find all pixels on the center line of the character C.  */
extern void __declspec(dllexport) __stdcall
find_centerline_pixels (pixel_outline_list_type *outline_list,
                        bitmap_type, color_type bg_color,
                        at_progress_func notify_progress, address progress_data,
                        at_testcancel_func test_cancel, address testcancel_data);

#elif _IMPORTING
/* Find all pixels on the center line of the character C.  */
extern void __declspec(dllimport) __stdcall
find_centerline_pixels (pixel_outline_list_type *outline_list,
                        bitmap_type, color_type bg_color,
                        at_progress_func notify_progress, address progress_data,
                        at_testcancel_func test_cancel, address testcancel_data);

#else
/* Find all pixels on the center line of the character C.  */
extern void
find_centerline_pixels (pixel_outline_list_type *outline_list,
                        bitmap_type, color_type bg_color,
                        at_progress_func notify_progress, at_address progress_data,
                        at_testcancel_func test_cancel, at_address testcancel_data);

#endif /* */

extern unsigned char
GetColor(at_bitmap_type bitmap, unsigned int row, unsigned int col);

extern void
SetColor(at_bitmap_type *bitmap, unsigned int row, unsigned int col,
         unsigned char color);

#endif /* not CENTERLINE_H */
