/***************************************************************************
   drawwing.h  -  Convert wing bitmap to curves.
                             -------------------
    begin                : Mon Mar 11 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DRAWWING_H
#define DRAWWING_H

#include "pxl-outline.h"
#include "types.h"
#include "vector.h"
#include "spline.h"


typedef struct{
  unsigned tip;
  at_real_coord tip_coord;
  unsigned top;
  unsigned bottom;
  unsigned left;
  unsigned right;
  at_real_coord bottom_coord;
  at_real real_left;
  at_real real_right;
  at_real upper;
  at_real lower;
  unsigned UpperEnd;
  unsigned LowerEnd;
  double rotation_angle;
  at_real width;    // width of wing from top to bottom
  at_real big_width;// width of whole wing can be bigger than width 
  double length;    //is unsigned enough
}wing_type;

extern void
AddBorder(at_bitmap_type *bitmap);

extern void
EndVeins(at_bitmap_type *bitmap);

extern void
ApplyThreshold(at_bitmap_type *bitmap, unsigned char threshold);

extern wing_type
GetWing(pixel_outline_type WingOutline, unsigned surround);

extern at_bitmap_type
CopyBmp(at_bitmap_type OldBmp);

extern at_bitmap_type
MaskWing(at_bitmap_type OldBmp, pixel_outline_type outline, wing_type wing);

extern pixel_outline_type
FindOneCenterline(bitmap_type bitmap, bitmap_type *marked,
    unsigned short original_row, unsigned short original_col);

extern void
smoothing1(at_bitmap_type *bitmap, unsigned size);

extern void
smoothing2(at_bitmap_type *bitmap, unsigned size);

extern void
find_short_otl(pixel_outline_list_type *outlines, unsigned too_short);

extern unsigned
GetDistantPixel(pixel_outline_type outline, unsigned start_pixel,
                unsigned end_pixel);

extern void
mark_end_veins(pixel_outline_list_type *outlines, unsigned border,
               unsigned too_short);

extern void
move_splines(spline_list_array_type *splines, wing_type *wing);

extern void
del_small_otl(at_bitmap_type *MaskedBmp, pixel_outline_list_type outlines,
              unsigned too_small);

extern at_splines_type *
dw_splines (at_bitmap_type * bitmap,
         at_fitting_opts_type * opts);
//         at_progress_func notify_progress,
//         at_address progress_data,
//         at_testcancel_func test_cancel,
//         at_address testcancel_data);

extern const char *
dw_version (void);

extern const char *
dw_home_site ();

unsigned
subtruct(at_bitmap_type *bmp, at_bitmap_type bgd);

#endif /* not DRAWWING_H */
